#include <time.h>

static int days_per_month[] = {
	31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31
};
static char *months[] = { 
	"Jan", "Feb", "Mar", "Apr", "May", "Jun",
	"Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
};
static char *days[] = {
	"Thu", "Fri", "Sat", "Sun", "Mon", "Tue", "Wed"
};

#define	MIN	60L
#define	HOUR	(60 * MIN)
#define	DAY	(24 * HOUR)
#define	YEAR	(365 * DAY)

char *
ctime(pt)
long *pt;
{
	struct tm tm;
	static char buf[26];
	register long t = *pt;

	tm.tm_year = 0;
	tm.tm_mon = 0;
	tm.tm_mday = 1;
	tm.tm_hour = 0;
	tm.tm_min = 0;
	tm.tm_sec = 0;
	while (t >= YEAR) {
		if ((tm.tm_year % 4) == 2)
			t -= DAY;
		tm.tm_year += 1;
		t -= YEAR;
	}
	tm.tm_year += 1970;
	days_per_month[1] = 28;
	if ((tm.tm_year % 4) == 0)
		days_per_month[1]++;
	while (t >= (days_per_month[tm.tm_mon] * DAY))
		t -= days_per_month[tm.tm_mon++] * DAY;
	while (t >= DAY) {
		t -= DAY;
		tm.tm_mday++;
	}
	while (t >= HOUR) {
		t -= HOUR;
		tm.tm_hour++;
	}
	while (t >= MIN) {
		t -= MIN;
		tm.tm_min++;
	}
	tm.tm_sec = (int) t;
	sprintf(buf, "%s %s %2d %02d:%02d:%02d %d\n",
		days[(t / DAY) % 7], months[tm.tm_mon],
		tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec, tm.tm_year); 
	return buf;
}
