#ifdef ACK
	.sect	.text
	.sect	.rom
	.sect	.data
	.sect	.bss
#endif ACK

	.sect	.text
start:
	bra	boot		! 000: jump to loader
	.ascii	"MINIX "	! 002: 6 byte identification
	.data1	0,0,0		! 008: volume serial
	.data1	0,2		! 00B: 512 bytes/sector (low byte first)
	.data1	2		! 00D: 2 sectors/cluster
	.data1	1,0		! 00E: reserved sector (low byte first)
	.data1	2		! 010: number of FATS
	.data1	112,0		! 011: number of dirs (low byte first)
	.data1	208,2		! 013: 720 sectors (low byte first)
	.data1	248		! 015: media descriptor (80 track SS)
	.data1	5,0		! 016: sectors/FAT (low byte first)
	.data1	9,0		! 018: sectors/track (low byte first)
	.data1	1,0		! 01A: number of sides (low byte first)
	.data1	0,0		! 01C: hidden sectors (low byte first)

! offsets in this boot block:
magic	= 502
nsect	= 504
fsckd	= 506
zero	= 508
fsckt	= 510

BIOS	= 13
RWABS	= 4
GETBPB	= 7

_bootdev	= 0x0446
ldaddr		= 0x040000

boot:
	move.w	_bootdev.l,-(sp)
	move.w	#GETBPB,-(sp)
	trap	#BIOS
	add.w	#4,sp
	tst.l	d0
	beq	fail
	clr.w	d6		! start with block 0
	move.w	start+nsect(pc),d4
	move.l	#ldaddr,a3	! load address in memory

read:
	tst.w	d4
	beq	1f
	bsr	rwabs
	bne	fail
1:
	lea	copy(pc),a0
	lea	start(pc),a1
	sub.l	a1,a0
	add.l	#ldaddr,a0
	jmp	(a0)		! jump to copy routine at ldaddr

copy:
	move.w	#0x2700,sr
	move.l	#8,a0
	move.l	#ldaddr+0x208,a1! start address of minix
	move.l	#0x400,d0
2:	move.l	(a1)+,(a0)+
	cmp.l	a0,d0
	bne	2b
	add.l	#0x200,a0	! skip tos variables
	add.l	#0x200,a1
	clr.l	d0
	move.w	start+nsect(pc),d0
	asl.l	#8,d0		! multiply
	asl.l	#1,d0		! with 512
3:	move.l	(a1)+,(a0)+
	cmp.l	a0,d0
	bne	3b
	move.l	ldaddr+0x204,a0
	jmp	(a0)		! minix boot adres

fail:
	clr.l	d0		! cannot load MINIX; try next device
	rts

rwabs:
	move.w	_bootdev.l,-(sp)
	move.w	d6,-(sp)
	move.w	d4,-(sp)
	move.l	a3,-(sp)
	clr.w	-(sp)
	move.w	#RWABS,-(sp)
	trap	#BIOS
	add.w	#14,a7
	tst.w	d0
	rts
